SystemOrganization addCategory: #SoftwareDesign!
SystemOrganization addCategory: #'SoftwareDesign-Model'!

Object subclass: #SDBerlinSBahnGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDBerlinSBahnGraph class methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 18:51:22.714'!
createGraph
	| graph nodeA nodeB nodeC nodeD nodeE arcA arcD arcE arcB arcC |
	
	graph := SDNavGraph new.
	
	nodeA := SDNavNode createOnGraph: graph withName: 'NodeA'.
	nodeB := SDNavNode createOnGraph: graph withName: 'NodeB'.   
	nodeC := SDNavNode createOnGraph: graph withName: 'NodeC'.
	nodeD := SDNavNode createOnGraph: graph withName: 'NodeD'.   
	nodeE := SDNavNode createOnGraph: graph withName: 'NodeE'.
	
	arcA := SDNavArc createOnGraph: graph between: nodeA and: nodeB.
	arcB := SDNavArc createOnGraph: graph between: nodeA and: nodeC.
	arcC := SDNavArc createOnGraph: graph between: nodeC and: nodeD.
	arcD := SDNavArc createOnGraph: graph between: nodeD and: nodeE.
	arcE := SDNavArc createOnGraph: graph between: nodeE and: nodeE.   
	
	^ graph! !

Object subclass: #SDNavArc
	instanceVariableNames: 'connecting duration connectingNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavArc class methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 18:44:00.965'!
createOnGraph: aGraph between: aNode and: anotherNode

	| arc |
	
	arc := SDNavArc new.
	arc nodes add: aNode.
	arc nodes add: anotherNode.
	
	aGraph addArc: arc.			
	
	^ arc ! !

!SDNavArc methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 19:03:12.437'!
initialize 

	super initialize.
	
	connectingNodes := OrderedCollection new.! !

Object subclass: #SDNavGraph
	instanceVariableNames: 'nodes arcs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/13/2012 18:32:02.809'!
addArc: anArc

	arcs add: anArc! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/13/2012 18:31:45.238'!
addNode: aNode

	nodes add: aNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/13/2012 18:21:04.696'!
arcs
	^ arcs duplicate! !

!SDNavGraph methodsFor: 'initialization' stamp: 'GNS 11/13/2012 18:59:50.807'!
initialize

	super initialize.
	
	nodes := OrderedCollection new.
	arcs := OrderedCollection new.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/13/2012 18:30:48.321'!
nodes
	^ nodes duplicate ! !

Object subclass: #SDNavNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavNode class methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 18:53:58.888'!
createOnGraph: aGraph withName: aName

	| node |
	
	node := SDNavNode new.
	node := aName.
	
	aGraph addNode: node.			
	
	^ node ! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/13/2012 18:39:06.364'!
name
	^ name! !

SystemWindow subclass: #SDNavMainWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindow methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 17:54:29.428'!
initialize
	| rectangle|
	
	
	super initialize.
	
	self setLabel: 'Navigation System'.
	
	rectangle := PasteUpMorph new.
	rectangle color: Color yellow.
	rectangle referencePosition: self position + (12 @ 30).
	rectangle topLeft: self position + (12 @ 30).
	rectangle bounds: (300@150).
	
	
	self addMorph: rectangle.
	  
	
	
	
	
	! !
